<!doctype html>
<html>
  <head>

    <meta charset="utf-8"/>
    <title>FSS | Canvas Basic Example</title>
    <meta name="author" content="Matthew Wagerfield"/>
    <meta name="viewport" content="initial-scale=1.0, user-scalable=no"/>

    <style>
    body {
      background: #111118;
      margin: 0;
    }
    .container {
      position: absolute;
      height: 100%;
      width: 100%;
    }
    #angle-bg {
      height: 100%;
      left: 0;
      position: absolute;
      top: 0;
      width: 100%;
      z-index: -1;
    }
    </style>

  </head>
  <body>
    <div id="angle-bg">
    </div>
    <!-- <div id="container" class="container">
      <div id="output" class="container">
      <canvas width="1850" height="150" style="display: block;"></canvas></div>
      <div id="vignette" class="overlay vignette">
      </div>
      <div id="noise" class="overlay noise">
      </div>
      <div id="ui" class="wrapper">
        <header id="header" class="header">
          <img class="logo" src="assets/graphics/logo.svg">
          <h1>Flat Surface Shader</h1>
        </header>
        <article id="information" class="information">
          <p>Admit it, 3D is cool. But, you know what's cooler? 2D.<br>I love WebGL, but unfortunately it doesn't work everywhere.</p>
          <p>This lighting simulation can be configured to use either the 2D context of a canvas element or an array of SVG polygons to draw the triangles. It also utilises native Float32Arrays to store numerical data for highly optimised calculations.</p>
          <p>This is a collaborative effort between<br><a href="http://matthew.wagerfield.com">Matthew Wagerfield</a> and <a href="http://www.behance.net/vanschneider">Tobias van Schneider</a> – a couple of pandas trying to make the web a more magical place.</p>
        </article>
        <footer id="footer" class="footer">
          <iframe id="twitter-widget-0" scrolling="no" frameborder="0" allowtransparency="true" allowfullscreen="true" class="twitter-follow-button twitter-follow-button-rendered" style="position: static; visibility: visible; width: 149px; height: 20px;" title="Twitter Follow Button" src="https://platform.twitter.com/widgets/follow_button.2b2d73daf636805223fb11d48f3e94f7.en.html#dnt=false&amp;id=twitter-widget-0&amp;lang=en&amp;screen_name=wagerfield&amp;show_count=false&amp;show_screen_name=true&amp;size=m&amp;time=1680247891885" data-screen-name="wagerfield"></iframe> &amp;
          <iframe id="twitter-widget-1" scrolling="no" frameborder="0" allowtransparency="true" allowfullscreen="true" class="twitter-follow-button twitter-follow-button-rendered" style="position: static; visibility: visible; width: 180px; height: 20px;" title="Twitter Follow Button" src="https://platform.twitter.com/widgets/follow_button.2b2d73daf636805223fb11d48f3e94f7.en.html#dnt=false&amp;id=twitter-widget-1&amp;lang=en&amp;screen_name=schneidertobias&amp;show_count=false&amp;show_screen_name=true&amp;size=m&amp;time=1680247891885" data-screen-name="schneidertobias"></iframe>
        </footer>
      </div>
      <ul id="links" class="links">
        <li><a class="download" href="https://raw.github.com/wagerfield/flat-surface-shader/master/deploy/fss.js" target="_blank">fss.js</a></li>
        <li><a class="download" href="https://raw.github.com/wagerfield/flat-surface-shader/master/deploy/fss.min.js" target="_blank">fss.min.js</a></li>
        <li><a class="source" href="https://github.com/wagerfield/flat-surface-shader" target="_blank">GitHub</a></li>
        <li><a class="design" href="http://www.behance.net/gallery/Flat-Surface-Shader/7826469" target="_blank">Behance</a></li>
      </ul>
    </div> -->
    <!-- <div id="controls" class="controls">
      <div class="dg main" style="width: 245px;"><ul><li class="folder"><div class="dg"><ul><li class="title">UI</li><li class="cr boolean"><div><span class="property-name">show</span><div class="c"><input type="checkbox" checked="checked"></div></div></li></ul></div></li><li class="folder"><div class="dg"><ul><li class="title">Render</li><li class="cr string"><div><span class="property-name">renderer</span><div class="c"><select><option value="webgl">webgl</option><option value="canvas">canvas</option><option value="svg">svg</option></select></div></div></li></ul></div></li><li class="folder"><div class="dg"><ul class="closed"><li class="title">Mesh</li><li class="cr string color" style="border-left-color: rgb(85, 85, 85);"><div><span class="property-name">ambient</span><div class="c"><input type="text" style="outline: none; text-align: center; color: rgb(255, 255, 255); border: 0px; font-weight: bold; text-shadow: rgba(0, 0, 0, 0.7) 0px 1px 1px; background-color: rgb(85, 85, 85);"><div class="selector" style="width: 122px; height: 102px; padding: 3px; background-color: rgb(34, 34, 34); box-shadow: rgba(0, 0, 0, 0.3) 0px 1px 3px;"><div class="field-knob" style="position: absolute; width: 12px; height: 12px; border: 2px solid rgb(255, 255, 255); box-shadow: rgba(0, 0, 0, 0.5) 0px 1px 3px; border-radius: 12px; z-index: 1; margin-left: -7px; margin-top: 59.6667px; background-color: rgb(85, 85, 85);"></div><div class="saturation-field" style="width: 100px; height: 100px; border: 1px solid rgb(85, 85, 85); margin-right: 3px; display: inline-block; cursor: pointer; background: -webkit-linear-gradient(left, rgb(255, 255, 255) 0%, rgb(255, 0, 0) 100%);"><div style="width: 100%; height: 100%; background: -webkit-linear-gradient(top, rgba(0, 0, 0, 0) 0%, rgb(0, 0, 0) 100%);"></div></div><div class="hue-field" style="width: 15px; height: 100px; display: inline-block; border: 1px solid rgb(85, 85, 85); cursor: ns-resize; background: -webkit-linear-gradient(top, rgb(255, 0, 0) 0%, rgb(255, 0, 255) 17%, rgb(0, 0, 255) 34%, rgb(0, 255, 255) 50%, rgb(0, 255, 0) 67%, rgb(255, 255, 0) 84%, rgb(255, 0, 0) 100%);"><div class="hue-knob" style="position: absolute; width: 15px; height: 2px; border-right: 4px solid rgb(255, 255, 255); z-index: 1; margin-top: 100px;"></div></div></div></div></div></li><li class="cr string color" style="border-left-color: rgb(255, 255, 255);"><div><span class="property-name">diffuse</span><div class="c"><input type="text" style="outline: none; text-align: center; color: rgb(0, 0, 0); border: 0px; font-weight: bold; text-shadow: rgba(255, 255, 255, 0.7) 0px 1px 1px; background-color: rgb(255, 255, 255);"><div class="selector" style="width: 122px; height: 102px; padding: 3px; background-color: rgb(34, 34, 34); box-shadow: rgba(0, 0, 0, 0.3) 0px 1px 3px;"><div class="field-knob" style="position: absolute; width: 12px; height: 12px; border: 2px solid rgb(0, 0, 0); box-shadow: rgba(0, 0, 0, 0.5) 0px 1px 3px; border-radius: 12px; z-index: 1; margin-left: -7px; margin-top: -7px; background-color: rgb(255, 255, 255);"></div><div class="saturation-field" style="width: 100px; height: 100px; border: 1px solid rgb(85, 85, 85); margin-right: 3px; display: inline-block; cursor: pointer; background: -webkit-linear-gradient(left, rgb(255, 255, 255) 0%, rgb(255, 0, 0) 100%);"><div style="width: 100%; height: 100%; background: -webkit-linear-gradient(top, rgba(0, 0, 0, 0) 0%, rgb(0, 0, 0) 100%);"></div></div><div class="hue-field" style="width: 15px; height: 100px; display: inline-block; border: 1px solid rgb(85, 85, 85); cursor: ns-resize; background: -webkit-linear-gradient(top, rgb(255, 0, 0) 0%, rgb(255, 0, 255) 17%, rgb(0, 0, 255) 34%, rgb(0, 255, 255) 50%, rgb(0, 255, 0) 67%, rgb(255, 255, 0) 84%, rgb(255, 0, 0) 100%);"><div class="hue-knob" style="position: absolute; width: 15px; height: 2px; border-right: 4px solid rgb(255, 255, 255); z-index: 1; margin-top: 100px;"></div></div></div></div></div></li><li class="cr number has-slider"><div><span class="property-name">width</span><div class="c"><div><input type="text"></div><div class="slider"><div class="slider-fg" style="width: 58.9744%;"></div></div></div></div></li><li class="cr number has-slider"><div><span class="property-name">height</span><div class="c"><div><input type="text"></div><div class="slider"><div class="slider-fg" style="width: 58.9744%;"></div></div></div></div></li><li class="cr number has-slider"><div><span class="property-name">depth</span><div class="c"><div><input type="text"></div><div class="slider"><div class="slider-fg" style="width: 20%;"></div></div></div></div></li><li class="cr number has-slider"><div><span class="property-name">segments</span><div class="c"><div><input type="text"></div><div class="slider"><div class="slider-fg" style="width: 78.9474%;"></div></div></div></div></li><li class="cr number has-slider"><div><span class="property-name">slices</span><div class="c"><div><input type="text"></div><div class="slider"><div class="slider-fg" style="width: 36.8421%;"></div></div></div></div></li><li class="cr number has-slider"><div><span class="property-name">xRange</span><div class="c"><div><input type="text"></div><div class="slider"><div class="slider-fg" style="width: 80%;"></div></div></div></div></li><li class="cr number has-slider"><div><span class="property-name">yRange</span><div class="c"><div><input type="text"></div><div class="slider"><div class="slider-fg" style="width: 10%;"></div></div></div></div></li><li class="cr number has-slider"><div><span class="property-name">speed</span><div class="c"><div><input type="text"></div><div class="slider"><div class="slider-fg" style="width: 20%;"></div></div></div></div></li></ul></div></li><li class="folder"><div class="dg"><ul><li class="title">Light</li><li class="cr boolean"><div><span class="property-name">autopilot</span><div class="c"><input type="checkbox" checked="checked"></div></div></li><li class="cr string color" style="border-left-color: rgb(136, 0, 102);"><div><span class="property-name">ambient</span><div class="c"><input type="text" style="outline: none; text-align: center; color: rgb(255, 255, 255); border: 0px; font-weight: bold; text-shadow: rgba(0, 0, 0, 0.7) 0px 1px 1px; background-color: rgb(136, 0, 102);"><div class="selector" style="width: 122px; height: 102px; padding: 3px; background-color: rgb(34, 34, 34); box-shadow: rgba(0, 0, 0, 0.3) 0px 1px 3px;"><div class="field-knob" style="position: absolute; width: 12px; height: 12px; border: 2px solid rgb(255, 255, 255); box-shadow: rgba(0, 0, 0, 0.5) 0px 1px 3px; border-radius: 12px; z-index: 1; margin-left: 93px; margin-top: 39.6667px; background-color: rgb(136, 0, 102);"></div><div class="saturation-field" style="width: 100px; height: 100px; border: 1px solid rgb(85, 85, 85); margin-right: 3px; display: inline-block; cursor: pointer; background: -webkit-linear-gradient(left, rgb(255, 255, 255) 0%, rgb(255, 0, 191) 100%);"><div style="width: 100%; height: 100%; background: -webkit-linear-gradient(top, rgba(0, 0, 0, 0) 0%, rgb(0, 0, 0) 100%);"></div></div><div class="hue-field" style="width: 15px; height: 100px; display: inline-block; border: 1px solid rgb(85, 85, 85); cursor: ns-resize; background: -webkit-linear-gradient(top, rgb(255, 0, 0) 0%, rgb(255, 0, 255) 17%, rgb(0, 0, 255) 34%, rgb(0, 255, 255) 50%, rgb(0, 255, 0) 67%, rgb(255, 255, 0) 84%, rgb(255, 0, 0) 100%);"><div class="hue-knob" style="position: absolute; width: 15px; height: 2px; border-right: 4px solid rgb(255, 255, 255); z-index: 1; margin-top: 12.5px;"></div></div></div></div></div></li><li class="cr string color" style="border-left-color: rgb(255, 136, 0);"><div><span class="property-name">diffuse</span><div class="c"><input type="text" style="outline: none; text-align: center; color: rgb(255, 255, 255); border: 0px; font-weight: bold; text-shadow: rgba(0, 0, 0, 0.7) 0px 1px 1px; background-color: rgb(255, 136, 0);"><div class="selector" style="width: 122px; height: 102px; padding: 3px; background-color: rgb(34, 34, 34); box-shadow: rgba(0, 0, 0, 0.3) 0px 1px 3px;"><div class="field-knob" style="position: absolute; width: 12px; height: 12px; border: 2px solid rgb(255, 255, 255); box-shadow: rgba(0, 0, 0, 0.5) 0px 1px 3px; border-radius: 12px; z-index: 1; margin-left: 93px; margin-top: -7px; background-color: rgb(255, 136, 0);"></div><div class="saturation-field" style="width: 100px; height: 100px; border: 1px solid rgb(85, 85, 85); margin-right: 3px; display: inline-block; cursor: pointer; background: -webkit-linear-gradient(left, rgb(255, 255, 255) 0%, rgb(255, 136, 0) 100%);"><div style="width: 100%; height: 100%; background: -webkit-linear-gradient(top, rgba(0, 0, 0, 0) 0%, rgb(0, 0, 0) 100%);"></div></div><div class="hue-field" style="width: 15px; height: 100px; display: inline-block; border: 1px solid rgb(85, 85, 85); cursor: ns-resize; background: -webkit-linear-gradient(top, rgb(255, 0, 0) 0%, rgb(255, 0, 255) 17%, rgb(0, 0, 255) 34%, rgb(0, 255, 255) 50%, rgb(0, 255, 0) 67%, rgb(255, 255, 0) 84%, rgb(255, 0, 0) 100%);"><div class="hue-knob" style="position: absolute; width: 15px; height: 2px; border-right: 4px solid rgb(255, 255, 255); z-index: 1; margin-top: 91.1111px;"></div></div></div></div></div></li><li class="cr number has-slider"><div><span class="property-name">count</span><div class="c"><div><input type="text"></div><div class="slider"><div class="slider-fg" style="width: 40%;"></div></div></div></div></li><li class="cr number has-slider"><div><span class="property-name">zOffset</span><div class="c"><div><input type="text"></div><div class="slider"><div class="slider-fg" style="width: 20%;"></div></div></div></div></li></ul></div></li><li class="folder"><div class="dg"><ul><li class="title">Export</li><li class="cr number has-slider"><div><span class="property-name">width</span><div class="c"><div><input type="text"></div><div class="slider"><div class="slider-fg" style="width: 48.7179%;"></div></div></div></div></li><li class="cr number has-slider"><div><span class="property-name">height</span><div class="c"><div><input type="text"></div><div class="slider"><div class="slider-fg" style="width: 23.0769%;"></div></div></div></div></li><li class="cr boolean"><div><span class="property-name">drawLights</span><div class="c"><input type="checkbox"></div></div></li><li class="cr number has-slider"><div><span class="property-name">minLightX</span><div class="c"><div><input type="text"></div><div class="slider"><div class="slider-fg" style="width: 40%;"></div></div></div></div></li><li class="cr number has-slider"><div><span class="property-name">maxLightX</span><div class="c"><div><input type="text"></div><div class="slider"><div class="slider-fg" style="width: 60%;"></div></div></div></div></li><li class="cr number has-slider"><div><span class="property-name">minLightY</span><div class="c"><div><input type="text"></div><div class="slider"><div class="slider-fg" style="width: 20%;"></div></div></div></div></li><li class="cr number has-slider"><div><span class="property-name">maxLightY</span><div class="c"><div><input type="text"></div><div class="slider"><div class="slider-fg" style="width: 40%;"></div></div></div></div></li><li class="cr function"><div><span class="property-name">export</span><div class="c"><div class="button"></div></div></div></li></ul></div></li></ul><div class="close-button" style="width: 245px;">Close Controls</div></div></div> -->

    <script src="../deploy/prefixfree.min.js"></script>
    <script src="../deploy/dat.gui.min.js"></script>
    <script src="../deploy/fss.js"></script>
    <script src="../deploy/example.js"></script>
    <script>

    var container = document.getElementById('container');
    var renderer = new FSS.CanvasRenderer();
    var scene = new FSS.Scene();
    var light = new FSS.Light('#111122', '#FF0022');
    var geometry = new FSS.Plane(600, 400, 6, 4);
    var material = new FSS.Material('#FFFFFF', '#FFFFFF');
    var mesh = new FSS.Mesh(geometry, material);
    var now, start = Date.now();

    function initialise() {
      scene.add(mesh);
      scene.add(light);
      container.appendChild(renderer.element);
      window.addEventListener('resize', resize);
    }

    function resize() {
      renderer.setSize(container.offsetWidth, container.offsetHeight);
    }

    function animate() {
      now = Date.now() - start;
      light.setPosition(300*Math.sin(now*0.001), 200*Math.cos(now*0.0005), 60);
      renderer.render(scene);
      requestAnimationFrame(animate);
    }

    initialise();
    resize();
    animate();

    </script>

  </body>
</html>
